diff a/src/hotspot/share/classfile/vmIntrinsics.hpp b/src/hotspot/share/classfile/vmIntrinsics.hpp
--- a/src/hotspot/share/classfile/vmIntrinsics.hpp
+++ b/src/hotspot/share/classfile/vmIntrinsics.hpp
@@ -596,10 +596,22 @@
   do_intrinsic(_notifyJvmtiVThreadEnd, java_lang_VirtualThread, notifyJvmtiEnd_name, void_method_signature, F_RN)       \
   do_intrinsic(_notifyJvmtiVThreadMount, java_lang_VirtualThread, notifyJvmtiMount_name, bool_void_signature, F_RN)     \
   do_intrinsic(_notifyJvmtiVThreadUnmount, java_lang_VirtualThread, notifyJvmtiUnmount_name, bool_void_signature, F_RN) \
   do_intrinsic(_notifyJvmtiVThreadHideFrames, java_lang_VirtualThread, notifyJvmtiHideFrames_name, bool_void_signature, F_RN) \
                                                                                                                         \
+  do_intrinsic(_shipilev_magic_timestamp,             net_shipilev_Magic, timestamp_name,            void_long_signature,   F_SN) \
+    do_name(timestamp_name,             "timestamp")                                                                              \
+  do_intrinsic(_shipilev_magic_timestamp_serial,      net_shipilev_Magic, timestampSerial_name,      void_long_signature,   F_SN) \
+    do_name(timestampSerial_name,       "timestampSerial")                                                                        \
+  do_intrinsic(_shipilev_magic_sizeOf,                net_shipilev_Magic, sizeOf_name,               object_long_signature, F_SN) \
+    do_name(sizeOf_name,                "sizeOf0")                                                                                \
+  do_intrinsic(_shipilev_magic_addressOf,             net_shipilev_Magic, addressOf_name,            object_long_signature, F_SN) \
+    do_name(addressOf_name,             "addressOf0")                                                                             \
+  do_intrinsic(_shipilev_magic_getReferencedObjects,  net_shipilev_Magic, getReferencedObjects_name, object_object_array_int_signature, F_SN)  \
+    do_name(getReferencedObjects_name,  "getReferencedObjects")                                                                  \
+    do_class(net_shipilev_Magic,        "net/shipilev/Magic")                                                           \
+                                                                                                                        \
   /* support for UnsafeConstants */                                                                                     \
   do_class(jdk_internal_misc_UnsafeConstants,      "jdk/internal/misc/UnsafeConstants")                                 \
                                                                                                                         \
   /* support for Unsafe */                                                                                              \
   do_class(jdk_internal_misc_Unsafe,               "jdk/internal/misc/Unsafe")                                          \
